<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑消息表' : '添加消息表'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="消息类型" name="t">
        <a-input
          allow-clear
          placeholder="请输入消息类型"
          v-model:value="form.t"
        />
      </a-form-item>
      <a-form-item label="消息标题" name="title">
        <a-input
          allow-clear
          placeholder="请输入消息标题"
          v-model:value="form.title"
        />
      </a-form-item>
      <a-form-item label="消息内容" name="content">
        <a-input
          allow-clear
          placeholder="请输入消息内容"
          v-model:value="form.content"
        />
      </a-form-item>
      <a-form-item label="发送者，1系统" name="from">
        <a-input
          allow-clear
          placeholder="请输入发送者，1系统"
          v-model:value="form.from"
        />
      </a-form-item>
      <a-form-item label="接收者" name="to">
        <a-input
          allow-clear
          placeholder="请输入接收者"
          v-model:value="form.to"
        />
      </a-form-item>
      <a-form-item label="是否已读，1是 0否" name="isRead">
        <a-input
          allow-clear
          placeholder="请输入是否已读，1是 0否"
          v-model:value="form.isRead"
        />
      </a-form-item>
      <a-form-item label="关联表名" name="tableName">
        <a-input
          allow-clear
          placeholder="请输入关联表名"
          v-model:value="form.tableName"
        />
      </a-form-item>
      <a-form-item label="关联表id" name="tableId">
        <a-input
          allow-clear
          placeholder="请输入关联表id"
          v-model:value="form.tableId"
        />
      </a-form-item>
      <a-form-item label="读取时间" name="readTime">
        <a-input
          allow-clear
          placeholder="请输入读取时间"
          v-model:value="form.readTime"
        />
      </a-form-item>
      <a-form-item label="更新时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入更新时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkMessage, updateThinkMessage } from '@/api/think/thinkMessage';
  import { ThinkMessage } from '@/api/think/thinkMessage/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkMessage | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkMessage>({
    id: undefined,
    t: undefined,
    title: undefined,
    content: undefined,
    from: undefined,
    to: undefined,
    isRead: undefined,
    tableName: undefined,
    tableId: undefined,
    readTime: undefined,
    createTime: undefined,
    updateTime: undefined,
    thinkMessageId: undefined,
    thinkMessageName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkMessageName: [
      {
        required: true,
        type: 'string',
        message: '请填写消息表名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkMessage : addThinkMessage;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
